Subject: Re: [PATCH v2 07/19 5.15.y] minmax: simplify and clarify min_t()/max_t() implementation

From: David Laight <[email-masked]>
Date: Mon, 6 Oct 2025 21:35:03 +0100

On Mon, 6 Oct 2025 12:47:45 +0200
Greg KH <[email-masked]> wrote:

(I've had to trim the 'To' list to send this...)

> On Fri, Oct 03, 2025 at 12:59:54PM +0000, Eliav Farber wrote:
> > From: Linus Torvalds <[email-masked]>
> > 
> > [ Upstream commit 017fa3e89187848fd056af757769c9e66ac3e93d ]
> > 
> > This simplifies the min_t() and max_t() macros by no longer making them
> > work in the context of a C constant expression.
> > 
> > That means that you can no longer use them for static initializers or
> > for array sizes in type definitions, but there were only a couple of
> > such uses, and all of them were converted (famous last words) to use
> > MIN_T/MAX_T instead.
> > 
> > Cc: David Laight <[email-masked]>
> > Cc: Lorenzo Stoakes <[email-masked]>
> > Signed-off-by: Linus Torvalds <[email-masked]>
> > Signed-off-by: Eliav Farber <[email-masked]>  
> 
> Eliav, your testing infrastructure needs some work, this patch breaks
> the build on this kernel tree:
> 
> In file included from ./include/linux/kernel.h:16,
>                  from ./include/linux/list.h:9,
>                  from ./include/linux/wait.h:7,
>                  from ./include/linux/wait_bit.h:8,
>                  from ./include/linux/fs.h:6,
>                  from fs/erofs/internal.h:10,
>                  from fs/erofs/zdata.h:9,
>                  from fs/erofs/zdata.c:6:
> fs/erofs/zdata.c: In function ‘z_erofs_decompress_pcluster’:
> fs/erofs/zdata.h:185:61: error: ISO C90 forbids variable length array ‘pages_onstack’ [-Werror=vla]
>   185 |         min_t(unsigned int, THREAD_SIZE / 8 / sizeof(struct page *), 96U)
>       |                                                             ^~~~

That constant seems to get (renamed and) changed to 32 in a later patch.
I'm not sure of the rational for the min() at all.
I think THREAD_SIZE is the size of the kernel stack? Or at least related to it.
The default seems to be 8k on x86-64 and 4k or 8k on i386.
So it is pretty much always going to be 96.

Linus added MIN() that can be used for array sizes.
But I'd guess this could just be changed to 32 - need to ask the erofs guys.

	David

> ./include/linux/minmax.h:49:23: note: in definition of macro ‘__cmp_once_unique’
>    49 |         ({ type ux = (x); type uy = (y); __cmp(op, ux, uy); })
>       |                       ^
> ./include/linux/minmax.h:164:27: note: in expansion of macro ‘__cmp_once’
>   164 | #define min_t(type, x, y) __cmp_once(min, type, x, y)
>       |                           ^~~~~~~~~~
> fs/erofs/zdata.h:185:9: note: in expansion of macro ‘min_t’
>   185 |         min_t(unsigned int, THREAD_SIZE / 8 / sizeof(struct page *), 96U)
>       |         ^~~~~
> fs/erofs/zdata.c:847:36: note: in expansion of macro ‘Z_EROFS_VMAP_ONSTACK_PAGES’
>   847 |         struct page *pages_onstack[Z_EROFS_VMAP_ONSTACK_PAGES];
>       |                                    ^~~~~~~~~~~~~~~~~~~~~~~~~~
> cc1: all warnings being treated as errors
> 
> 
> I'll drop this whole series, please do a bit more testing before sending
> out a new version.
> 
> thanks,
> 
> greg k-h
>